Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Plugin API Estimated time: 0.00 hour

Target version: 5.1.0   

Resolution: Fixed Affected version:  

Description

When loading init.rb, uses sort (source:tags/5.0.5/lib/redmine/plugin_loader.rb#L117), but loading plugin's config/routes.rb does not

uses sort (source:tags/5.0.5/config/routes.rb#L400). In ruby-2.7 or earlier, Dir.glob does not sort. So, loading init.rb and loading

plugin's config/routes.rb are different.

This issue includes following patches:

0001-fix-order-of-loading-plugins-config-routes.rb.patch : minimal changes to fix with tests.

0002-refactor-to-more-simply-code.patch : refactor related codes.

Related issues:

Related to Redmine - Defect #39864: Backport fix of random failing integratio... Closed

Associated revisions

Revision 22327 - 2023-10-06 08:10 - Go MAEDA

Fix order of loading plugins' config/routes.rb (#38707).

Patch by Nishida Yuya.

Revision 22328 - 2023-10-06 08:12 - Go MAEDA

Add test for r22327 (#38707).

Patch by Nishida Yuya.

Revision 22329 - 2023-10-06 08:14 - Go MAEDA

Refactor: Simplify the code (#38707).

Patch by Nishida Yuya.

Revision 22330 - 2023-10-06 10:18 - Go MAEDA

Fix RuboCop offences introduced in r22328 (#38707).

Revision 22371 - 2023-10-23 19:51 - Marius BĂLTEANU

Fix typo in plugins_test.rb (#38707).

Revision 22373 - 2023-10-24 22:06 - Marius BĂLTEANU

Fixes a random failing test in test_plugins (integration/routing/plugins_test.rb) by enforcing the plugins path to tmp/plugins (#38707).

Revision 22374 - 2023-10-24 22:13 - Marius BĂLTEANU

Delete whole tmp/plugins directory (#38707).

History

#1 - 2023-06-26 16:40 - Go MAEDA

- Target version set to Candidate for next major release

#2 - 2023-08-29 03:25 - Go MAEDA

- Target version changed from Candidate for next major release to 5.1.0
Setting the target version to 5.1.0.

#3 - 2023-10-06 08:32 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

Committed the patch. Thank you.

#4 - 2023-10-23 19:41 - Marius BĂLTEANU

- Status changed from Closed to Reopened

There is a random failing test caused by this.

Can we take a look, please?

Failure:

RoutingPluginsTest#test_plugins [/var/lib/jenkins/workspace/trunk/DATABASE_ADAPTER/mysql/RUBY_VER/ruby-3.1/tes

t/test_helper.rb:323]:

A route matches "/plugin_articles", but references missing controller: PluginArticlesController

rails test test/integration/routing/plugins_test.rb:63

#5 - 2023-10-24 22:16 - Marius BĂLTEANU

- Status changed from Reopened to Closed

The random failing test most probably was caused by the custom plugins path defined in plugin_test.rb or plugin_loader_test.rb. I think I've fixed it by

explicit setting the plugins directory to tmp/test/plugins.

#6 - 2023-10-30 13:53 - Go MAEDA

- Tracker changed from Patch to Defect

- Resolution set to Fixed

#7 - 2023-12-13 14:29 - Vincent Robert

I'm investigating an issue that appears to be related to this change.

When running core tests with Redmine 5.1 and one plugin, I observe some random failures.

Here is an error when testing with the 'redmine_customize_core_fields' plugin (https://github.com/nanego/redmine_customize_core_fields) :

url_for: {:controller=>"/core_fields"}

Error:

CustomFieldEnumerationsControllerTest#test_destroy_enumeration_in_use_should_display_destroy_form:

ActionView::Template::Error: No route matches {:action=>"index", :controller=>"core_fields", :custom_field_id

=>"858", :id=>"1959"}

    lib/redmine/menu_manager.rb:190:in `render_single_menu_node'

More failing tests can be seen here: https://github.com/nanego/redmine_customize_core_fields/actions    

The errors do not appear when running Redmine at commit 7ba9cb1da6364aba9500ec60bcb25b9ad93e6773 (branch 5.1). But it shows up when I

add the two following commits and run at e5034f5ac0cd1992a8ff341e69441de407a06198

#8 - 2023-12-13 15:15 - Vincent Robert

The core tests are passing again when I comment these two lines:

+++ b/test/integration/routing/plugins_test.rb

@@ -53,7 +53,7 @@ class RoutingPluginsTest < Redmine::RoutingTest

     # Change plugin loader's directory for testing

-    Redmine::PluginLoader.directory = @tmp_plugins_path

+    # Redmine::PluginLoader.directory = @tmp_plugins_path

     Redmine::PluginLoader.load

     Redmine::PluginLoader.directories.each(&:run_initializer) # to define relative controllers

     RedmineApp::Application.instance.routes_reloader.reload!

___
   def setup_plugin(plugin_name, **relative_path_to_content)

-    Redmine::Plugin.directory = @tmp_plugins_path

+    # Redmine::Plugin.directory = @tmp_plugins_path

     plugin_path =  Redmine::Plugin.directory / plugin_name.to_s

     plugin_path.mkpath

 I finally understand the reason behind this issue.

Due to route reloading after changing the plugins' directory, the routes defined by my plugin are removed (this occurs because my plugin is still

located in the default directory).

A bug arises if my plugin adds an item to the admin menu : the route for this item is removed during the route reloading process.

#9 - 2023-12-13 17:54 - Marius BĂLTEANU

Indeed, that code from setup and teardown could lead to some random failing tests, but it was changed in the current trunk, please see r22516. Could

you give it a try with the new code to check if you still experiment random fails? If yes, please open a new issue because this one is already closed

and we can continue the investigation there. If everything it's ok, I think we can merge the fix also to 5.1-stable branch.

#10 - 2023-12-14 15:12 - Vincent Robert

After a quick test, it appears that the current trunk version is working fine. It would be great to integrate this fix into the current stable branch.

I will open a new issue if any new random failure tests arise as a result of these changes.

Thank you

#11 - 2023-12-17 04:13 - Marius BĂLTEANU

Vincent Robert wrote in #note-10:

After a quick test, it appears that the current trunk version is working fine. It would be great to integrate this fix into the current stable branch.

I will open a new issue if any new random failure tests arise as a result of these changes.

Thank you

 Merged to 5.1-stable in #39864.

#12 - 2023-12-17 04:13 - Marius BĂLTEANU

- Related to Defect #39864: Backport fix of random failing integration test for plugin routes  added

Files

0001-fix-order-of-loading-plugins-config-routes.rb.patch 4.45 KB 2023-06-13 Nishida Yuya

0002-refactor-to-more-simply-code.patch 1.33 KB 2023-06-13 Nishida Yuya
